local AuctionExtensionAddon = Inspect.Addon.Detail(Inspect.Addon.Current())

function AuctionExtension.AE.Init(handle, addonIdentifier)
	if addonIdentifier == AuctionExtensionAddon.identifier then
		AuctionExtension.AE.InitSettings()
		AuctionExtension.AE.Player = Inspect.Unit.Detail("player").name

		AuctionExtension.AE.UI.Context = UI.CreateContext(AuctionExtensionAddon.identifier)
		AuctionExtension.AE.UI.Button = AuctionExtension.GUI.CreateButton(AuctionExtension.AE.UI.Context, iif(MINIMAPDOCKER, nil, AuctionExtensionUISettings.button.x), iif(MINIMAPDOCKER, nil, AuctionExtensionUISettings.button.y), 32, 32, 0, "button")
		if MINIMAPDOCKER then
			MINIMAPDOCKER.Register(AuctionExtensionAddon.toc.Name, AuctionExtension.AE.UI.Button, AuctionExtension.AE.ToggleWindow)
		else
			AuctionExtension.EGUI.AttachDragFrame(AuctionExtension.AE.UI.Button, false, "button", false)
		end
		AuctionExtension.AE.UI.Button.Event.LeftClick = AuctionExtension.AE.ToggleWindow

		AuctionExtension.AE.UI.Window = UI.CreateFrame("RiftWindow", "", AuctionExtension.AE.UI.Context)
		AuctionExtension.AE.UI.Window:SetVisible(AuctionExtension.AE.Visible)
		AuctionExtension.AE.UI.Window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", AuctionExtensionUISettings.window.x, AuctionExtensionUISettings.window.y)
		AuctionExtension.AE.UI.Window:SetWidth(900)
		AuctionExtension.AE.UI.Window:SetHeight(475)
		AuctionExtension.AE.UI.Window:SetTitle(string.upper(AuctionExtensionAddon.toc.Name))
		AuctionExtension.AE.UI.Window:SetController("content")
		AuctionExtension.AE.UI.Window:SetLayer(100)
		AuctionExtension.EGUI.AttachDragFrame(AuctionExtension.AE.UI.Window, true, "window", true)

		AuctionExtension.GUI.CreateText(AuctionExtension.AE.UI.Window, "BOTTOMRIGHT", -10, -5, "v." .. AuctionExtensionAddon.toc.Version, 100, nil, {.5, .5, .5, 1})
		AuctionExtension.GUI.CreateRiftButton(AuctionExtension.AE.UI.Window, "TOPRIGHT", 4, -41, 2).Event.LeftPress = AuctionExtension.AE.ToggleWindow

		AuctionExtension.AE.UI.ScanBagsButton = AuctionExtension.GUI.CreateRiftButton(AuctionExtension.AE.UI.Window, "BOTTOMLEFT", 12, -6, 5, "Scan bags")
		AuctionExtension.AE.UI.ScanBagsButton.Event.LeftPress = AuctionExtension.AE.ScanBags
		AuctionExtension.AE.UI.ScanMineButton = AuctionExtension.GUI.CreateRiftButton(AuctionExtension.AE.UI.Window, "BOTTOMLEFT", 142, -6, 5, "Scan mine")
		AuctionExtension.AE.UI.ScanMineButton.Event.LeftPress = AuctionExtension.AE.ScanMineAuction
		AuctionExtension.AE.UI.ScanButton = AuctionExtension.GUI.CreateRiftButton(AuctionExtension.AE.UI.Window, "BOTTOMLEFT", 322, -6, 5, "Scan auction")
		AuctionExtension.AE.UI.ScanButton.Event.LeftPress = AuctionExtension.AE.ScanAuction
		AuctionExtension.AE.UI.ActionButton = AuctionExtension.GUI.CreateRiftButton(AuctionExtension.AE.UI.Window, "BOTTOMLEFT", 502, -6, 5, "Action")
		AuctionExtension.AE.UI.ActionButton.Event.LeftPress = AuctionExtension.AE.Action
		AuctionExtension.AE.UI.BuyoutButton = AuctionExtension.GUI.CreateRiftButton(AuctionExtension.AE.UI.Window, "BOTTOMLEFT", 632, -6, 5, "Bid")
		AuctionExtension.AE.UI.BuyoutButton.Event.LeftPress = AuctionExtension.AE.Buyout

		AuctionExtension.GUI.CreateTileTexture(AuctionExtension.AE.UI.Window, 10, 10, 41, 10, 35, 35, 2, "img/border.png", "img/borderh.png", "img/borderv.png")
		AuctionExtension.AE.UI.List = AuctionExtension.GUI.CreateMaskedLayer(AuctionExtension.AE.UI.Window, "TOPLEFT", 20, 20, 842, 403, 0, {0, 0, 0, 0.5}, AuctionExtension.AE.OnWheel )
		AuctionExtension.AE.UI.Scrollbar = AuctionExtension.GUI.CreateScrollbar(AuctionExtension.AE.UI.Window, "TOPLEFT", 865, 21, 16, 402, 10, "vertical", AuctionExtension.AE.OnScroll)

		for i = 1, 250 do
			AuctionExtension.AE.UI.Rows[i] = AuctionExtension.EGUI.CreateRow(AuctionExtension.AE.UI.List.layer, i, AuctionExtension.AE.OnPost)
		end

		AuctionExtension.AE.ScanSource = 0
		AuctionExtension.AE.ScanType = 0
		AuctionExtension.AE.ScanActive = 0
		AuctionExtension.AE.ScanQuantity = 0
		AuctionExtension.AuctionListFilled = false
		AuctionExtension.OnInteraction(nil, "auction", Inspect.Interaction("auction"))

		Command.Console.Display("general", true, "<font color=\"#AD48FB\">" .. AuctionExtensionAddon.name .. " ver." .. AuctionExtensionAddon.toc.Version .. " loaded. Type /" .. AuctionExtension.AE.Command .. " to show a window.</font>", true)
	end
end

function AuctionExtension.AE.InitSettings()
	if AuctionExtensionUISettings == nil then AuctionExtensionUISettings = {} end
	if AuctionExtensionUISettings.button == nil then AuctionExtensionUISettings.button = { x = math.floor(UIParent:GetWidth() / 2), y = math.floor(UIParent:GetHeight() / 2) } end
	if AuctionExtensionUISettings.window == nil then AuctionExtensionUISettings.window = { x = math.floor(UIParent:GetWidth() / 4), y = math.floor(UIParent:GetHeight() / 4) } end
end

function AuctionExtension.AE.ToggleWindow()
	AuctionExtension.AE.Visible = not AuctionExtension.AE.Visible
	AuctionExtension.AE.UI.Window:SetVisible(AuctionExtension.AE.Visible)
	AuctionExtension.AE.ScanActive = 0
	AuctionExtension.AE.PostActive = false
	AuctionExtension.AE.ScanBags()
	AuctionExtension.AE.UpdateInterface(true)
end

function AuctionExtension.AE.ScanBags(flag)
	if AuctionExtension.AE.Visible then
		AuctionExtension.AE.ScanSource = 0
		AuctionExtension.List = {}
		AuctionExtension.SortedList = {}
		local items = Inspect.Item.List(Utility.Item.Slot.Inventory())
		for k, v in pairs(items) do
			if v then
				local itemDetail = Inspect.Item.Detail(v)
				if itemDetail ~= nil and itemDetail.category ~= nil and string.find(itemDetail.category, "artifact") ~= nil then
					if (AuctionExtension.List[itemDetail.name] == nil) then
						AuctionExtension.List[itemDetail.name] = { Invalidate = false, id = v, name = itemDetail.name, icon = itemDetail.icon, rarity = itemDetail.rarity, stack = itemDetail.stack }
						table.insert(AuctionExtension.SortedList, itemDetail.name)
					else
						AuctionExtension.List[itemDetail.name].stack = AuctionExtension.List[itemDetail.name].stack + itemDetail.stack
					end
				end
			end
		end
		if flag == nil then
			AuctionExtension.AE.ShowList()
			AuctionExtension.AE.UpdateInterface(true)
		end
	end
end

function AuctionExtension.AE.ShowList()
	table.sort(AuctionExtension.SortedList)
	for i = 1, 250 do
		AuctionExtension.AE.UI.Rows[i].Update(AuctionExtension.List[AuctionExtension.SortedList[i]], AuctionExtension.AE.ScanSource)
	end
	AuctionExtension.AE.UI.Scrollbar.SetScroll(#AuctionExtension.SortedList)
end

function AuctionExtension.AE.OnScroll()
	AuctionExtension.AE.UI.List.layer:SetPoint("TOPLEFT", AuctionExtension.AE.UI.List, "TOPLEFT", 0, -AuctionExtension.AE.UI.Scrollbar:GetPosition())
end

function AuctionExtension.AE.OnWheel(delta)
	AuctionExtension.AE.UI.Scrollbar:SetPosition(math.min(math.max(0, AuctionExtension.AE.UI.Scrollbar:GetPosition() + delta * 2), AuctionExtension.AE.UI.Scrollbar.maximum))
end

function AuctionExtension.OnInteraction(handle, interaction, state)
	if interaction == "auction" then
		AuctionExtension.AE.Interaction = state
		if not state then AuctionExtension.AE.ScanActive = 0 end
		AuctionExtension.AE.UpdateInterface(true)
	end
end

function AuctionExtension.AE.ScanAuction()
	if Inspect.Queue.Status("auctionfullscan") ~= false then
		AuctionExtension.AE.ScanType = 1
		AuctionExtension.AE.ScanActive = 1
		AuctionExtension.AuctionList = {}
		AuctionExtension.AuctionListFilled = false
		AuctionExtension.AE.UpdateInterface(true)

		AuctionExtension.AE.BuyoutList = {}
		AuctionExtension.AE.BuyoutPosition = 1

		pcall(Command.Auction.Scan, { type = "search", category = "artifact", sort = "pricePerUnit" })
	end
end

function AuctionExtension.AE.ScanMineAuction()
	if Inspect.Queue.Status("auctionfullscan") ~= false then
		AuctionExtension.AE.ScanSource = 1
		AuctionExtension.AE.ScanType = 2
		AuctionExtension.AE.ScanActive = 1
		AuctionExtension.AE.ScanQuantity = 0
		AuctionExtension.List = {}
		AuctionExtension.SortedList = {}
		AuctionExtension.AE.UpdateInterface(true)
		pcall(Command.Auction.Scan, { type = "mine" })
	end
end

function AuctionExtension.AE.Buyout()
	if AuctionExtension.AE.BuyoutPosition <= #AuctionExtension.AE.BuyoutList then
		AuctionExtension.AE.PostActive = true
		Command.Auction.Bid(AuctionExtension.AE.BuyoutList[AuctionExtension.AE.BuyoutPosition].id, AuctionExtension.AE.BuyoutList[AuctionExtension.AE.BuyoutPosition].price, AuctionExtension.AE.OnBuyoutComplete)
	end
end

function AuctionExtension.AE.OnBuyoutComplete(failed)
	if failed then return end
	AuctionExtension.AE.BuyoutPosition = AuctionExtension.AE.BuyoutPosition + 1
	AuctionExtension.AE.UI.BuyoutButton:SetText("Bid (" .. AuctionExtension.AE.BuyoutPosition .. "/" .. #AuctionExtension.AE.BuyoutList .. ")")
	AuctionExtension.AE.PostActive = false
end

function AuctionExtension.AE.Action()
	for i = 1, 250 do
		if AuctionExtension.AE.UI.Rows[i].action < 3 and AuctionExtension.AE.UI.Rows[i].enabled then
			AuctionExtension.AE.UI.Rows[i].create.Event.LeftPress()
			break
		end
	end
	AuctionExtension.AE.UpdateInterfaceAction(true)
end

function AuctionExtension.AE.UpdateInterfaceAction(flag1)
	local flag2 = false
	for i = 1, 250 do
		if AuctionExtension.AE.UI.Rows[i].action < 3 and AuctionExtension.AE.UI.Rows[i].enabled then
			flag2 = true
		end
	end
	AuctionExtension.AE.UI.ActionButton:SetEnabled(flag1 and flag2)
end

function AuctionExtension.AE.UpdateInterface(flag)
	if AuctionExtension.AE.Visible then
		AuctionExtension.AE.UI.ScanMineButton:SetEnabled(AuctionExtension.AuctionListFilled and AuctionExtension.AE.Interaction and AuctionExtension.AE.ScanActive == 0 and Inspect.Queue.Status("auctionfullscan") ~= false)
		AuctionExtension.AE.UI.ScanButton:SetEnabled(AuctionExtension.AE.Interaction and AuctionExtension.AE.ScanActive == 0 and Inspect.Queue.Status("auctionfullscan") ~= false)
		AuctionExtension.AE.UI.ScanMineButton:SetText(iif(AuctionExtension.AE.ScanActive == 0 or AuctionExtension.AE.ScanType == 1, "Scan mine" .. iif(AuctionExtension.AE.ScanQuantity == 0, "", " (" .. AuctionExtension.AE.ScanQuantity .. ")"), "Scanning..." .. iif(AuctionExtension.AE.ScanActive == 3, " " .. math.floor(100 * AuctionExtension.AE.ScanTablePosition / (#AuctionExtension.AE.ScanTable + 1)) .. "%", "")))
		AuctionExtension.AE.UI.ScanButton:SetText(iif(AuctionExtension.AE.ScanActive == 0 or AuctionExtension.AE.ScanType == 2, "Scan auction", "Scanning..." .. iif(AuctionExtension.AE.ScanActive == 3, " " .. math.floor(100 * AuctionExtension.AE.ScanTablePosition / (#AuctionExtension.AE.ScanTable + 1)) .. "%", "")))
		if flag then
			for i = 1, 250 do
				AuctionExtension.AE.UI.Rows[i].SetEnabled(AuctionExtension.AE.Interaction and AuctionExtension.AE.ScanActive == 0)
			end
		end
		AuctionExtension.AE.UpdateInterfaceAction(AuctionExtension.AE.Interaction and AuctionExtension.AE.ScanActive == 0)
	end
end

function AuctionExtension.OnAuctionScan(handle, type, auctions)
	if AuctionExtension.AE.ScanActive == 1 then
		AuctionExtension.AE.ScanTable = auctions
		AuctionExtension.AE.ScanActive = 2
	end
end

function AuctionExtension.AE.OnUpdateEnd()
	if Inspect.System.Watchdog() > 0.1 then
		if AuctionExtension.AE.ScanActive == 4 then
			AuctionExtension.AE.ScanBags(true)
			if AuctionExtension.List[AuctionExtension.AE.PostSourceId] == nil then
				AuctionExtension.AE.ScanActive = 0
				AuctionExtension.AE.OnPostComplete()
			end
		end

		if AuctionExtension.AE.ScanActive == 3 then
			while AuctionExtension.AE.ScanTablePosition <= #AuctionExtension.AE.ScanTable and Inspect.System.Watchdog() > 0.1 do
				local auctionDetail = Inspect.Auction.Detail(AuctionExtension.AE.ScanTable[AuctionExtension.AE.ScanTablePosition])
				local itemDetail = Inspect.Item.Detail(auctionDetail.item)

				if auctionDetail.buyout ~= nil then
					if AuctionExtension.AE.ScanType == 1 then
						if AuctionExtension.AuctionList[itemDetail.name] == nil then
							AuctionExtension.AuctionList[itemDetail.name] = { minPrice = auctionDetail.buyout, maxPrice = auctionDetail.buyout, ownPrice = iif(auctionDetail.seller == AuctionExtension.AE.Player, auctionDetail.buyout, 0) }
						else
							AuctionExtension.AuctionList[itemDetail.name].minPrice = math.min(AuctionExtension.AuctionList[itemDetail.name].minPrice, auctionDetail.buyout)
							AuctionExtension.AuctionList[itemDetail.name].maxPrice = math.max(AuctionExtension.AuctionList[itemDetail.name].maxPrice, auctionDetail.buyout)
							if auctionDetail.seller == AuctionExtension.AE.Player then AuctionExtension.AuctionList[itemDetail.name].ownPrice = auctionDetail.buyout end
						end
					else
						AuctionExtension.AE.ScanQuantity = AuctionExtension.AE.ScanQuantity + 1
						if AuctionExtension.AuctionList[itemDetail.name] then
							if AuctionExtension.AuctionList[itemDetail.name].minPrice < auctionDetail.buyout then
								AuctionExtension.List[itemDetail.name] = { Invalidate = false, auctionId = auctionDetail.id, id = itemDetail.id, name = itemDetail.name, icon = itemDetail.icon, rarity = itemDetail.rarity, stack = auctionDetail.itemStack }
								table.insert(AuctionExtension.SortedList, itemDetail.name)
							end
						end
					end
					if auctionDetail.buyout / iif(auctionDetail.itemStack == nil, 1, auctionDetail.itemStack) <= AuctionExtension.PriceList[itemDetail.rarity or "common"].buyout and AuctionExtension.IgnoreList[itemDetail.name] == nil then
						table.insert(AuctionExtension.AE.BuyoutList, { id = auctionDetail.id, price = auctionDetail.buyout })
					end
				end
				AuctionExtension.AE.ScanTablePosition = AuctionExtension.AE.ScanTablePosition + 1
			end
			AuctionExtension.AE.UpdateInterface(false)

			if AuctionExtension.AE.ScanTablePosition > #AuctionExtension.AE.ScanTable then
				AuctionExtension.AE.ScanActive = 0
				AuctionExtension.AuctionListFilled = true
				AuctionExtension.AE.ShowList()
				AuctionExtension.AE.UpdateInterface(true)
			end
		end

		if AuctionExtension.AE.ScanActive == 2 then
			local list = {}
			for k, v in pairs(AuctionExtension.AE.ScanTable) do
				table.insert(list, k)
			end
			AuctionExtension.AE.ScanTable = list
			AuctionExtension.AE.ScanTablePosition = 1
			AuctionExtension.AE.ScanActive = 3
		end
	end
end

function AuctionExtension.AE.OnPost(data, action, price)
	if (Inspect.Queue.Status("global") ~= false and Inspect.Interaction("auction") and AuctionExtension.AE.PostActive ~= true) or action == 1 then
		if action == 0 then
			AuctionExtension.AE.PostActive = true
			local stack = Inspect.Item.Detail(data.id)
			if stack ~= nil then stack = stack.stack else stack = 0 end
			if stack == 1 then
				pcall(Command.Auction.Post, data.id, 48, price, price, AuctionExtension.AE.OnPostComplete)
			else
				if stack > 1 then
					Command.Item.Split(data.id, stack - 1)
					pcall(Command.Auction.Post, data.id, 48, price, price, AuctionExtension.AE.OnPostComplete)
				end
			end
		elseif action == 1 then
			AuctionExtension.AE.ScanActive = 4
			AuctionExtension.AE.PostActive = true
			AuctionExtension.AE.PostSourceId = data.name
			Command.Item.Destroy(data.id)
		elseif action == 2 then
			AuctionExtension.AE.PostActive = true
			AuctionExtension.AE.PostSourceId = data.name
			pcall(Command.Auction.Cancel, data.auctionId, AuctionExtension.AE.OnCancelComplete)
		end
	end
end

function AuctionExtension.AE.OnPostComplete()
	local position = AuctionExtension.AE.UI.Scrollbar:GetPosition()
	AuctionExtension.AE.ScanBags()
	AuctionExtension.AE.UI.Scrollbar:SetPosition(math.min(position, AuctionExtension.AE.UI.Scrollbar.maximum))
	AuctionExtension.AE.PostActive = false
end

function AuctionExtension.AE.OnCancelComplete()
	AuctionExtension.List[AuctionExtension.AE.PostSourceId].Invalidate = true
	for i = 1, 250 do
		if AuctionExtension.SortedList[i] == AuctionExtension.AE.PostSourceId then
			AuctionExtension.AE.UI.Rows[i].SetEnabled(false)
		end
	end
	AuctionExtension.AE.PostActive = false
end